##############################################################################
#
# Copyright (c) 1999 Johan Carlsson
# All rights reserved. Written by Johan Carlsson <johanc@torped.se>
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. The name of the author may not be used to endorse or promote products
#    derived from this software without specific prior written permission
#
# Disclaimer
#
#   THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
#   IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
#   OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
#   IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
#   INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
#   NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
#   THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# In accordance with the license provided for by the software upon
# which some of the source code has been derived or used, the following
# acknowledgement is hereby provided:
#
#      "This product includes software developed by Digital Creations
#      for use in the Z Object Publishing Environment
#      (http://www.zope.org/)."
#
##############################################################################

"""VirtualStream Object for Local Filesystem 1.0
"""

__version__='$Revision: 1.1 $'[11:-2]


#import sys, os, string, re, stat, urllib, glob, errno, time, tempfile
import Globals
from Acquisition import Implicit
from Globals import DTMLFile
from types import StringType
import AccessControl
from os import path
from DateTime import DateTime
from webdav.common import rfc1123_date

class VirtualStream(Implicit):

    _path=None
    content_type="application/octet-stream"
    title=""
    meta_type="VirtualStream"

    security = AccessControl.ClassSecurityInfo()

    def __init__(self, id, file, content_type="application/octet-stream"):

        self.id=self.__name__=id
        self._path = file.name
        self.content_type=content_type


    security.declareProtected( 'View', 'index_html' )
    def index_html(self,REQUEST=None, RESPONSE=None, content_type=None):
        """
        Returns a stream version of the object
        point to by the _path attribute.

        Content Type sets to content_type

        """
        if path.exists(self._path):


            file_size = path.getsize(self._path)
            p_mtime = path.getmtime(self._path)


            ##DENNA KOD R TESTAD RIKTIGT VL,
            ##DEN BEHVS ANTAGLIGEN BARA FR PROXY SERVRAR
            ##S JAG TAR BORT DEN.
            ### HTTP If-Modified-Since header handling.
            ##header=REQUEST.get_header('If-Modified-Since', None)
            ##if header is not None:
            ##    header=header.split(';')[0]
            ##    # Some proxies seem to send invalid date strings for this
            ##    # header. If the date string is not valid, we ignore it
            ##    # rather than raise an error to be generally consistent
            ##    # with common servers such as Apache (which can usually
            ##    # understand the screwy date string as a lucky side effect
            ##    # of the way they parse it).
            ##    # This happens to be what RFC2616 tells us to do in the face of an
            ##    # invalid date.
            ##    try:    mod_since=long(DateTime(header).timeTime())
            ##    except: mod_since=None
            ##    if mod_since is not None:
            ##        if p_mtime:
            ##            last_mod = long(DateTime(p_mtime).timeTime())
            ##        else:
            ##            last_mod = long(0)
            ##        if last_mod > 0 and last_mod <= mod_since:
            ##            # Set header values since apache caching will return Content-Length
            ##            # of 0 in response if size is not set here
            ##            RESPONSE.setHeader('Last-Modified', rfc1123_date(p_mtime))
            ##            RESPONSE.setHeader('Content-Type', self.content_type)
            ##            RESPONSE.setHeader('Content-Length', file_size)
            ##            RESPONSE.setHeader('Accept-Ranges', 'bytes')
            ##            RESPONSE.setStatus(304)
            ##            return ''


            RESPONSE.setHeader('Content-Type',   self.content_type)
            RESPONSE.setHeader('Content-Length', file_size)
            RESPONSE.setHeader('Last-Modified', rfc1123_date(p_mtime))

            file = open(self._path, "rb")
            buffer=file.read(8196*1024)
            while buffer:
                RESPONSE.write(buffer)
                buffer=file.read(8196*1024)

        else:
            raise "FileError", "File doesn't exist"



    security.declareProtected( 'View', 'manage_main' )
    manage_main = index_html

Globals.InitializeClass( VirtualStream )
